-- phpMyAdmin SQL Dump
-- version 3.3.2
-- http://www.phpmyadmin.net
--
-- WEB: www.squidworks.net
-- Generation Time: Oct 31, 2012 at 12:34 PM
-- Server version: 5.0.84
-- PHP Version: 5.2.10
-- MAGMA Version .01a
-- Created By Shannon Anderson
-- 

create database MAGMA;
use MAGMA;
SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Database: `MAGMA`
--


-- --------------------------------------------------------

--
-- Table structure for table `ALERTS`
--

DROP TABLE IF EXISTS `ALERTS`;
CREATE TABLE IF NOT EXISTS `ALERTS` (
  `ID` int(8) NOT NULL auto_increment,
  `HOSTID` varchar(8) NOT NULL,
  `PAGEGROUP` int(8) NOT NULL,
  `SERVICE` varchar(254) NOT NULL,
  `COLOR` varchar(16) NOT NULL,
  `TIME` varchar(32) NOT NULL,
  `DURATION` varchar(8) NOT NULL,
  `EMAIL` varchar(64) NOT NULL,
  `RECOVERED` int(1) NOT NULL default '0',
  `ONCALL` int(1) NOT NULL default '0',
  `REPEAT` varchar(8) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=25 ;

-- --------------------------------------------------------

--
-- Table structure for table `EXTERNAL_TESTS`
--

DROP TABLE IF EXISTS `EXTERNAL_TESTS`;
CREATE TABLE IF NOT EXISTS `EXTERNAL_TESTS` (
  `ID` int(3) NOT NULL auto_increment,
  `HOST` int(12) NOT NULL,
  `CONN` int(1) NOT NULL default '0',
  `HTTP` varchar(512) default NULL,
  `FTP` int(1) NOT NULL default '0',
  `SSH` int(1) NOT NULL default '0',
  `TELNET` int(1) NOT NULL default '0',
  `SMTP` int(1) NOT NULL default '0',
  `POP3` int(1) NOT NULL default '0',
  `IMAP` int(1) NOT NULL default '0',
  `FTPS` int(1) NOT NULL default '0',
  `TELNETS` int(1) NOT NULL default '0',
  `SMTPS` int(1) NOT NULL default '0',
  `POP3S` int(1) NOT NULL default '0',
  `IMAPS` int(1) NOT NULL default '0',
  `ESXI` int(1) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `HOST` (`HOST`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=181 ;

-- --------------------------------------------------------

--
-- Table structure for table `HOSTDISKS`
--

DROP TABLE IF EXISTS `HOSTDISKS`;
CREATE TABLE IF NOT EXISTS `HOSTDISKS` (
  `ID` int(8) NOT NULL auto_increment,
  `HOSTID` int(8) NOT NULL,
  `DISK` varchar(64) NOT NULL,
  `WARN` varchar(8) NOT NULL,
  `PANIC` varchar(8) NOT NULL,
  `IGNORE` int(1) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=26 ;

-- --------------------------------------------------------

--
-- Table structure for table `HOSTLOGS`
--

DROP TABLE IF EXISTS `HOSTLOGS`;
CREATE TABLE IF NOT EXISTS `HOSTLOGS` (
  `ID` int(16) NOT NULL auto_increment,
  `HOSTID` int(8) NOT NULL,
  `LOG` varchar(64) NOT NULL,
  `MATCH` varchar(128) NOT NULL,
  `COLOR` varchar(16) NOT NULL,
  `IGNORE` varchar(64) default NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=19 ;

-- --------------------------------------------------------

--
-- Table structure for table `HOSTPROCS`
--

DROP TABLE IF EXISTS `HOSTPROCS`;
CREATE TABLE IF NOT EXISTS `HOSTPROCS` (
  `ID` int(16) NOT NULL auto_increment,
  `HOSTID` int(8) NOT NULL,
  `PROC` varchar(64) NOT NULL,
  `MINCOUNT` int(3) NOT NULL,
  `MAXCOUNT` int(3) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=304 ;

-- --------------------------------------------------------

--
-- Table structure for table `HOSTS`
--

DROP TABLE IF EXISTS `HOSTS`;
CREATE TABLE IF NOT EXISTS `HOSTS` (
  `ID` int(11) NOT NULL auto_increment,
  `HOSTNAME` varchar(64) NOT NULL,
  `IPADDRESS` varchar(16) NOT NULL,
  `NAME` varchar(64) default NULL,
  `COMMENT` varchar(64) default NULL,
  `DATE_ADDED` datetime NOT NULL,
  `PAGEGROUP` int(5) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=182 ;

-- --------------------------------------------------------

--
-- Table structure for table `HOSTSVCS`
--

DROP TABLE IF EXISTS `HOSTSVCS`;
CREATE TABLE IF NOT EXISTS `HOSTSVCS` (
  `ID` int(16) NOT NULL auto_increment,
  `HOSTID` int(8) NOT NULL,
  `SERVICENAME` varchar(64) NOT NULL,
  `STARTUP` varchar(24) NOT NULL,
  `STATUS` varchar(16) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=463 ;

-- --------------------------------------------------------
--
-- Table structure for table `PAGEGROUPS`
--

DROP TABLE IF EXISTS `PAGEGROUPS`;
CREATE TABLE IF NOT EXISTS `PAGEGROUPS` (
  `ID` int(11) NOT NULL auto_increment,
  `NAME` varchar(64) NOT NULL,
  `TITLE` varchar(64) default NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=40 ;

-- --------------------------------------------------------

--
-- Table structure for table `SYSTEMTESTS`
--

DROP TABLE IF EXISTS `SYSTEMTESTS`;
CREATE TABLE IF NOT EXISTS `SYSTEMTESTS` (
  `ID` int(8) NOT NULL auto_increment,
  `HOSTID` int(8) NOT NULL,
  `MEMPHYSWARN` int(3) NOT NULL default '90',
  `MEMPHYSCRIT` int(3) NOT NULL default '95',
  `MEMACTWARN` int(3) NOT NULL default '90',
  `MEMACTCRIT` int(3) NOT NULL default '95',
  `MEMSWAPWARN` int(3) NOT NULL default '90',
  `MEMSWAPCRIT` int(3) NOT NULL default '95',
  `LOADWARN` int(3) NOT NULL default '90',
  `LOADCRIT` int(3) NOT NULL default '95',
  `UPTIME` int(4) NOT NULL default '15',
  `REBOOT` varchar(8) default NULL,
  `CLOCK` int(3) NOT NULL default '250',
  `DISKWARN` int(3) NOT NULL default '90',
  `DISKCRIT` int(3) NOT NULL default '95',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=177 ;

-- --------------------------------------------------------


