<?php
//Developed by Shannon Anderson 
//Date 8/12/2012
//For MAGMA  

function getURLdata($url) {
  $ch = curl_init();
  $timeout = 5;
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
  $data = curl_exec($ch);
  curl_close($ch);
  return $data;
}

function time_duration($seconds, $use = null, $zeros = false)
{
    // Define time periods
    $periods = array (
        'years'     => 31556926,
        'Months'    => 2629743,
        'weeks'     => 604800,
        'days'      => 86400,
        'hours'     => 3600,
        'minutes'   => 60,
        'seconds'   => 1
        );
 
    // Break into periods
    $seconds = (float) $seconds;
    $segments = array();
    foreach ($periods as $period => $value) {
        if ($use && strpos($use, $period[0]) === false) {
            continue;
        }
        $count = floor($seconds / $value);
        if ($count == 0 && !$zeros) {
            continue;
        }
        $segments[strtolower($period)] = $count;
        $seconds = $seconds % $value;
    }
 
    // Build the string
    $string = array();
    foreach ($segments as $key => $value) {
        $segment_name = substr($key, 0, -1);
        $segment = $value . ' ' . $segment_name;
        if ($value != 1) {
            $segment .= 's';
        }
        $string[] = $segment;
    }
 
    return implode('<br>', $string);
}

function getHostExternalTests($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM EXTERNAL_TESTS WHERE HOST = '$ID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        while($Rows = mysql_fetch_array($result)){
                $sys['ID'] = $Rows['ID'];
                $sys['HOST'] = $Rows['HOST'];
                $sys['CONN'] = $Rows['CONN'];
                $sys['HTTP'] = $Rows['HTTP'];
                $sys['FTP'] = $Rows['FTP'];
                $sys['SSH'] = $Rows['SSH'];
                $sys['TELNET'] = $Rows['TELNET'];
                $sys['SMTP'] = $Rows['SMTP'];
                $sys['POP3'] = $Rows['POP3'];
                $sys['IMAP'] = $Rows['IMAP'];
                $sys['FTPS'] = $Rows['FTPS'];
                $sys['TELNETS'] = $Rows['TELNETS'];
                $sys['SMTPS'] = $Rows['SMTPS'];
                $sys['POP3S'] = $Rows['POP3S'];
                $sys['IMAPS'] = $Rows['IMAPS'];
                $sys['ESXI'] = $Rows['ESXI'];
                }
    mysql_close($con);
    return($sys);
}

function getPageGroupHosts($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTS WHERE PAGEGROUP = '$ID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        $i =0;
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys[$i]['ID'] = $Rows['ID'];
                $sys[$i]['HOSTNAME'] = $Rows['HOSTNAME'];
                $sys[$i]['NAME'] = $Rows['NAME'];
                $sys[$i]['IPADDRESS'] = $Rows['IPADDRESS'];
                $sys[$i]['DATE_ADDED'] = $Rows['DATE_ADDED'];
                $sys[$i]['COMMENT'] = $Rows['COMMENT'];
                $sys[$i]['PAGEGROUP'] = $Rows['PAGEGROUP'];
                $i++;
                }
    mysql_close($con);
    return($sys);
}

function getPageGroups($dbhost,$dbuser,$dbpass,$db){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM PAGEGROUPS ORDER BY NAME";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        $i =0;
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys[$i]['ID'] = $Rows['ID'];
                $sys[$i]['NAME'] = $Rows['NAME'];
                $sys[$i]['TITLE'] = $Rows['TITLE'];
                $i++;
                }
    mysql_close($con);
    return($sys);
}

function getPageGroup($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM PAGEGROUPS WHERE ID = '$ID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys['NAME'] = $Rows['NAME'];
                $sys['TITLE'] = $Rows['TITLE'];
                }
    mysql_close($con);
    return($sys);
}


function addPageGroup($dbhost,$dbuser,$dbpass,$db,$NAME,$TITLE){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "SELECT ID,NAME FROM PAGEGROUPS WHERE NAME = '$NAME'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
    $numrow = mysql_num_rows($result1);
    if($numrow != 0){$ROTATION = 1;
	echo "The name ($NAME) is already in use please use a unique name<br>";
    }else{
	$SQL = "INSERT INTO PAGEGROUPS (NAME,TITLE) Values ('$NAME','$TITLE')";
#    echo $SQL;
	$result = mysql_query($SQL) or die('A error occured: ' . $SQL);
	}	

}

function getHostProcs($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTPROCS WHERE HOSTID = '$ID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        $i =0;
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys[$i]['ID'] = $Rows['ID'];
                $sys[$i]['PROC'] = $Rows['PROC'];
                $sys[$i]['MINCOUNT'] = $Rows['MINCOUNT'];
                $sys[$i]['MAXCOUNT'] = $Rows['MAXCOUNT'];
                $i++;
                }
    mysql_close($con);
    return($sys);
}
function getHostProcesses($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTPROCS WHERE HOSTID = '$ID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        $i =0;
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys[] = $Rows['PROC'];
                }
    mysql_close($con);
    return($sys);
}
function deleteHostProcesses($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM HOSTPROCS WHERE HOSTID = '$ID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
}
function deleteHostProcess($dbhost,$dbuser,$dbpass,$db,$ID,$PROCID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM HOSTPROCS WHERE HOSTID = '$ID' and ID = '$PROCID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
}

function updateHostProcesses($dbhost,$dbuser,$dbpass,$db,$ID,$PROC,$TYPE,$VALUE){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTPROCS WHERE HOSTID = '$ID' and PROC = '$PROC'";
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrow = mysql_num_rows($result);
    if($numrow == 1){
	$SQL3 = "UPDATE HOSTPROCS SET $TYPE = '$VALUE' WHERE HOSTID = '$ID' and PROC = '$PROC'";	
	$result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);
    }else{
	if($TYPE == "MAXCOUNT"){$MIN = 0; $MAX = $VALUE;}
	if($TYPE == "MINCOUNT"){$MIN = $VALUE; $MAX = 0;}
	$SQL3 = "INSERT INTO HOSTPROCS (HOSTID,PROC,MINCOUNT,MAXCOUNT) values('$ID','$PROC','$MIN','$MAX')";	
	$result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);
    }
}
function getHostLogs($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTLOGS WHERE HOSTID = '$ID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        $i =0;
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys[$i]['ID'] = $Rows['ID'];
                $sys[$i]['LOG'] = $Rows['LOG'];
                $sys[$i]['MATCH'] = $Rows['MATCH'];
                $sys[$i]['IGNORE'] = $Rows['IGNORE'];
                $sys[$i]['COLOR'] = $Rows['COLOR'];
                $i++;
                }
    mysql_close($con);
    return($sys);
}
function deleteHostLog($dbhost,$dbuser,$dbpass,$db,$HOSTID,$LOGID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM HOSTLOGS WHERE HOSTID = '$HOSTID' and ID = '$LOGID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
}

function addHostLog($dbhost,$dbuser,$dbpass,$db,$HOSTID,$LOG,$MATCH,$COLOR,$IGNORE){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL3 = "INSERT INTO HOSTLOGS (HOSTID,`LOG`,`MATCH`,`COLOR`,`IGNORE`) values('$HOSTID','$LOG','$MATCH','$COLOR','$IGNORE')";	
    $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);

}

function getHostDisks($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTDISKS WHERE HOSTID = '$ID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        $i =0;
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys[$i]['ID'] = $Rows['ID'];
                $sys[$i]['DISK'] = $Rows['DISK'];
                $sys[$i]['WARN'] = $Rows['WARN'];
                $sys[$i]['IGNORE'] = $Rows['IGNORE'];
                $sys[$i]['PANIC'] = $Rows['PANIC'];
                $i++;
                }
    mysql_close($con);
    return($sys);
}
function deleteHostDisk($dbhost,$dbuser,$dbpass,$db,$HOSTID,$DISKID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM HOSTDISKS WHERE HOSTID = '$HOSTID' and ID = '$DISKID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
}

function addHostDisk($dbhost,$dbuser,$dbpass,$db,$HOSTID,$DISK,$WARN,$PANIC,$IGNORE){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL3 = "INSERT INTO HOSTDISKS (HOSTID,`DISK`,`WARN`,`PANIC`,`IGNORE`) values('$HOSTID','$DISK','$WARN','$PANIC','$IGNORE')";	
    $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);

}


function getHostServices($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTSVCS WHERE HOSTID = '$ID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        $i =0;
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys[$i]['ID'] = $Rows['ID'];
                $sys[$i]['SERVICENAME'] = $Rows['SERVICENAME'];
                $sys[$i]['STARTUP'] = $Rows['STARTUP'];
                $sys[$i]['STATUS'] = $Rows['STATUS'];
                $i++;
                }
    mysql_close($con);
    return($sys);
}
function deleteHostServices($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM HOSTSVCS WHERE HOSTID = '$ID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
}

function updateHostServices($dbhost,$dbuser,$dbpass,$db,$ID,$NAME,$STARTUP,$STATUS,$DISPLAYNAME){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL3 = "INSERT INTO HOSTSVCS (HOSTID,SERVICENAME,STARTUP,STATUS) values('$ID','$NAME','$STARTUP','$STATUS')";	
    $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);

}
function deletePageGroup($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM PAGEGROUPS WHERE ID = '$ID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
    


}

function updatePageGroup($dbhost,$dbuser,$dbpass,$db,$ID,$NAME,$TITLE){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL3 = "UPDATE PAGEGROUPS SET NAME = '$NAME', TITLE = '$TITLE' where ID = '$ID'";	
    $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);

}

function getHost($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTS WHERE ID = '$ID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        while($Rows = mysql_fetch_array($result)){
                $sys['ID'] = $Rows['ID'];
                $sys['HOSTNAME'] = $Rows['HOSTNAME'];
                $sys['NAME'] = $Rows['NAME'];
                $sys['IPADDRESS'] = $Rows['IPADDRESS'];
                $sys['DATE_ADDED'] = $Rows['DATE_ADDED'];
                $sys['COMMENT'] = $Rows['COMMENT'];
                $sys['PAGEGROUP'] = $Rows['PAGEGROUP'];
                }
    mysql_close($con);
    return($sys);
}

function getHosts($dbhost,$dbuser,$dbpass,$db){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTS ORDER BY HOSTNAME";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        $i =0;
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys[$i]['ID'] = $Rows['ID'];
                $sys[$i]['HOSTNAME'] = $Rows['HOSTNAME'];
                $sys[$i]['NAME'] = $Rows['NAME'];
                $sys[$i]['IPADDRESS'] = $Rows['IPADDRESS'];
                $sys[$i]['DATE_ADDED'] = $Rows['DATE_ADDED'];
                $sys[$i]['COMMENT'] = $Rows['COMMENT'];
                $sys[$i]['PAGEGROUP'] = $Rows['PAGEGROUP'];
                $i++;
                }
    mysql_close($con);
    return($sys);
}


function addHost($dbhost,$dbuser,$dbpass,$db,$HOSTNAME,$IPADDRESS,$NAME,$COMMENT,$PAGEGROUP){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "SELECT ID,NAME FROM HOSTS WHERE HOSTNAME = '$HOSTNAME'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
    $numrow = mysql_num_rows($result1);
    if($numrow != 0){$ROTATION = 1;
	echo "The name ($HOSTNAME) is already in use please use a unique name<br>";
    }else{
        if($HOSTNAME != "" and $IPADDRESS != ""){
	    $SQL = "INSERT INTO HOSTS (HOSTNAME,IPADDRESS,NAME,COMMENT,DATE_ADDED,PAGEGROUP) Values ('$HOSTNAME','$IPADDRESS','$NAME','$COMMENT',NOW(),'$PAGEGROUP')";
    	    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    	    $ID = mysql_insert_id();
	    $SQL = "INSERT INTO EXTERNAL_TESTS (HOST,CONN,HTTP,FTP,SSH,TELNET,SMTP,POP3,IMAP,FTPS,TELNETS,SMTPS,POP3S,IMAPS,ESXI) Values ('$ID','0','','0','0','0','0','0','0','0','0','0','0','0','0')";
    	    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
	    $SQL3 = "INSERT INTO SYSTEMTESTS (HOSTID,MEMPHYSWARN,MEMPHYSCRIT,MEMACTWARN,MEMACTCRIT,MEMSWAPWARN,MEMSWAPCRIT,LOADWARN,LOADCRIT,UPTIME,REBOOT,CLOCK,DISKWARN,DISKCRIT) Values ('$ID','90','98','90','98','90','98','90','98','15','365d','120','89','95')";
	    $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);
	    	
	}else{
	    echo "A hostname and IP address are required to create a host.";
	}
#    echo $SQL;
	}	
}

function deleteHost($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM HOSTS WHERE ID = '$ID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
    $SQL1 = "DELETE FROM EXTERNAL_TESTS WHERE HOST = '$ID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
    


}

function updateHost($dbhost,$dbuser,$dbpass,$db,$ID,$HOSTNAME,$IPADDRESS,$NAME,$COMMENT,$PAGEGROUP,$CONN,$HTTP,$FTP,$SSH,$TELNET,$SMTP,$POP3,$IMAP,$FTPS,$TELNETS,$SMTPS,$POP3S,$IMAPS,$ESXI){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    if($HOSTNAME != "" and $IPADDRESS != ""){
	$SQL3 = "UPDATE HOSTS SET HOSTNAME = '$HOSTNAME', IPADDRESS = '$IPADDRESS', NAME = '$NAME', COMMENT = '$COMMENT', PAGEGROUP = '$PAGEGROUP' where ID = '$ID'";	
        $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);
	$SQL3 = "UPDATE EXTERNAL_TESTS SET CONN = '$CONN', HTTP = '$HTTP', FTP = '$FTP', SSH = '$SSH', TELNET = '$TELNET', SMTP = '$SMTP', POP3 = '$POP3', IMAP = '$IMAP', FTPS = '$FTPS', TELNETs = '$TELNETS', SMTPS = '$SMTPS', POP3S = '$POP3S', IMAPS = '$IMAPS', ESXI = '$ESXI'  where HOST = '$ID'";	
        $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);

    }else{
	echo "A hostname and IP address are required to create a host.";
    }

}


function getAlerts($dbhost,$dbuser,$dbpass,$db,$PAGEGROUP){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM ALERTS WHERE PAGEGROUP = '$PAGEGROUP'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        $i =0;
        #echo $numrows;
        while($Rows = mysql_fetch_array($result)){
                $sys[$i]['ID'] = $Rows['ID'];
                $sys[$i]['HOSTID'] = $Rows['HOSTID'];
                $sys[$i]['PAGEGROUP'] = $Rows['PAGEGROUP'];
                $sys[$i]['SERVICE'] = $Rows['SERVICE'];
                $sys[$i]['COLOR'] = $Rows['COLOR'];
                $sys[$i]['TIME'] = $Rows['TIME'];
                $sys[$i]['DURATION'] = $Rows['DURATION'];
                $sys[$i]['EMAIL'] = $Rows['EMAIL'];
                $sys[$i]['RECOVERED'] = $Rows['RECOVERED'];
                $sys[$i]['ONCALL'] = $Rows['ONCALL'];
                $sys[$i]['REPEAT'] = $Rows['REPEAT'];
                $i++;
                }
    mysql_close($con);
    return($sys);
}


function addAlert($dbhost,$dbuser,$dbpass,$db,$ID,$PAGEGROUP,$SERVICE,$COLOR,$TIME,$DURATION,$EMAIL,$RECOVERED,$ONCALL,$REPEAT){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
        if($EMAIL != "" or $ONCALL == "1"){
    	    if($SERVICE == "" and $RECOVERED != 1){$SERVICE = "*";}
	    $exp = explode("@",$ID);
	    if($exp[0] == "HOST"){
#		echo $exp[0];
		$HOSTID = $exp[1];	
		$SQL = "INSERT INTO ALERTS (HOSTID,PAGEGROUP,SERVICE,COLOR,`TIME`,DURATION,EMAIL,RECOVERED,ONCALL,`REPEAT`) Values ('$HOSTID','$PAGEGROUP','$SERVICE','$COLOR','$TIME','$DURATION','$EMAIL','$RECOVERED','$ONCALL','$REPEAT')";
    		$result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    	    }elseif($exp[0] = "PAGEGROUP"){
#		echo $exp[0];
		$HOSTID = "%";	
		$SQL = "INSERT INTO ALERTS (HOSTID,PAGEGROUP,SERVICE,COLOR,`TIME`,DURATION,EMAIL,RECOVERED,ONCALL,`REPEAT`) Values ('$HOSTID','$PAGEGROUP','$SERVICE','$COLOR','$TIME','$DURATION','$EMAIL','$RECOVERED','$ONCALL','$REPEAT')";
    		$result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    	    
    	    }else{
    		echo "We could not decode the ID to see if it was a host alarm or Page group alert";
    	    }	
	}else{
	    echo "A Email or Oncall must be selected to create an alert.";
	}
#    echo $SQL;
	

}

function deleteAlert($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM ALERTS WHERE ID = '$ID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);

}
function deleteHostAlerts($dbhost,$dbuser,$dbpass,$db,$HOSTID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM ALERTS WHERE HOSTID = '$HOSTID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);

}
function deleteHostExternalTests($dbhost,$dbuser,$dbpass,$db,$HOSTID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM EXTERNAL_TESTS WHERE HOST = '$HOSTID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);

}

function updateAlert($dbhost,$dbuser,$dbpass,$db,$ID,$HOSTID,$PAGEGROUP,$SERVICE,$COLOR,$TIME,$DURATION,$EMAIL,$RECOVERED,$ONCALL,$REPEAT){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
        if($EMAIL != "" or $ONCALL == "1"){
    	    if($SERVICE == "" and $RECOVERED != 1){$SERVICE = "*";}
	    $exp = explode("@",$HOSTID);
	    if($exp[0] == "HOST"){
		$HOSTID = $exp[1];	
		$SQL3 = "UPDATE ALERTS SET HOSTID = '$HOSTID', PAGEGROUP = '$PAGEGROUP', SERVICE = '$SERVICE', COLOR = '$COLOR', `TIME` = '$TIME', DURATION = '$DURATION', EMAIL = '$EMAIL', RECOVERED = '$RECOVERED', ONCALL = '$ONCALL', `REPEAT` = '$REPEAT'  WHERE ID = '$ID'";	
	        $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);
    	    }elseif($exp[0] = "PAGEGROUP"){
		$newHOSTID = "%";
		$SQL3 = "UPDATE ALERTS SET HOSTID = '$newHOSTID', PAGEGROUP = '$PAGEGROUP', SERVICE = '$SERVICE', COLOR = '$COLOR', `TIME` = '$TIME', DURATION = '$DURATION', EMAIL = '$EMAIL', RECOVERED = '$RECOVERED', ONCALL = '$ONCALL', `REPEAT` = '$REPEAT'  WHERE ID = '$ID'";	
	        $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);
    	    }else{
    		echo "We could not decode the ID to see if it was a host alarm or Page group alert";
    	    }	
#	    echo $SQL3;

    }else{
	echo "A Email or Oncall selected is required to update an Alert.";
    }

}

function getHostSystemTests($dbhost,$dbuser,$dbpass,$db,$HOSTID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM SYSTEMTESTS WHERE HOSTID = '$HOSTID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
        while($Rows = mysql_fetch_array($result)){
                $sys['MEMPHYSWARN'] = $Rows['MEMPHYSWARN'];
                $sys['MEMPHYSCRIT'] = $Rows['MEMPHYSCRIT'];
                $sys['MEMACTWARN'] = $Rows['MEMACTWARN'];
                $sys['MEMACTCRIT'] = $Rows['MEMACTCRIT'];
                $sys['MEMSWAPWARN'] = $Rows['MEMSWAPWARN'];
                $sys['MEMSWAPCRIT'] = $Rows['MEMSWAPCRIT'];
                $sys['LOADWARN'] = $Rows['LOADWARN'];
                $sys['LOADCRIT'] = $Rows['LOADCRIT'];
                $sys['UPTIME'] = $Rows['UPTIME'];
                $sys['REBOOT'] = $Rows['REBOOT'];
                $sys['CLOCK'] = $Rows['CLOCK'];
                $sys['DISKWARN'] = $Rows['DISKWARN'];
                $sys['DISKCRIT'] = $Rows['DISKCRIT'];
                }
    mysql_close($con);
    return($sys);
}


function updateSystemTests($dbhost,$dbuser,$dbpass,$db,$HOSTID,$MEMPHYSWARN,$MEMPHYSCRIT,$MEMACTWARN,$MEMACTCRIT,$MEMSWAPWARN,$MEMSWAPCRIT,$LOADWARN,$LOADCRIT,$UPTIME,$REBOOT,$CLOCK,$DISKWARN,$DISKCRIT){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
        if($HOSTID != ""){
    $SQL = "SELECT * FROM SYSTEMTESTS WHERE HOSTID = '$HOSTID'";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
	    if($numrows == 0){
		$SQL3 = "INSERT INTO SYSTEMTESTS (HOSTID,MEMPHYSWARN,MEMPHYSCRIT,MEMACTWARN,MEMACTCRIT,MEMSWAPWARN,MEMSWAPCRIT,LOADWARN,LOADCRIT,UPTIME,REBOOT,CLOCK,DISKWARN,DISKCRIT) Values ('$HOSTID','$MEMPHYSWARN','$MEMPHYSCRIT','$MEMACTWARN','$MEMACTCRIT','$MEMSWAPWARN','$MEMSWAPCRIT','$LOADWARN','$LOADCRIT','$UPTIME','$REBOOT','$CLOCK','$DISKWARN','$DISKCRIT')";
	        $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);
    	    }else{
		$SQL3 = "UPDATE SYSTEMTESTS SET  MEMPHYSWARN = '$MEMPHYSWARN', MEMPHYSCRIT = '$MEMPHYSCRIT', MEMACTWARN = '$MEMACTWARN', MEMACTCRIT = '$MEMACTCRIT', MEMSWAPWARN = '$MEMSWAPWARN', MEMSWAPCRIT = '$MEMSWAPCRIT', LOADWARN = '$LOADWARN', LOADCRIT = '$LOADCRIT', UPTIME = '$UPTIME', REBOOT = '$REBOOT', CLOCK = '$CLOCK', DISKWARN = '$DISKWARN', DISKCRIT = '$DISKCRIT'  WHERE HOSTID = '$HOSTID'";	
	        $result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);
    	    }	
#	    echo $SQL3;

    }else{
	echo "No HOSt ID was sent to update SYSTEM TESTS.";
    }

}


function deleteHostSystemTests($dbhost,$dbuser,$dbpass,$db,$ID){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL1 = "DELETE FROM SYSTEMTESTS WHERE HOSTID = '$ID'";
    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);

}


function activateAlerts($dbhost,$dbuser,$dbpass,$db,$alertfile){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM ALERTS ORDER BY PAGEGROUP";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
    $i =0;
    #echo $numrows;
    $file = fopen("$alertfile","w+") or exit("Unable to open file!");    
    while($Rows = mysql_fetch_array($result)){
        if($Rows['HOSTID'] == "%"){
            $PAGEGROUPID = $Rows['PAGEGROUP'];
	    $SQL1 = "SELECT * FROM PAGEGROUPS WHERE ID = $PAGEGROUPID";
	    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
    	    while($Row = mysql_fetch_array($result1)){
            	$PAGEGROUP = $Row['NAME'];
            	}
            $alert = "PAGE=\"$PAGEGROUP\"\t";
        }elseif(is_numeric($Rows['HOSTID'])){
            $HOSTID = $Rows['HOSTID'];
	    $SQL1 = "SELECT * FROM HOSTS WHERE ID = '$HOSTID'";
	    $result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
    	    while($Row = mysql_fetch_array($result1)){
            	 $HOSTNAME = $Row['HOSTNAME'];
            	}        
	    $alert = "HOST=$HOSTNAME\t";
        }else{
            echo "We could not understand the HostID value";
            exit();
    	    }
        if($Rows['SERVICE'] != ""){
    	    $SERVICE = $Rows['SERVICE'];
            $alert .= "SERVICE=$SERVICE\t";
            }
        if($Rows['COLOR'] != ""){
            $COLOR = $Rows['COLOR'];
            $alert .= "COLOR=$COLOR\t";
            }
        if($Rows['TIME'] != ""){
            $TIME = $Rows['TIME'];
            $alert .= "TIME=$TIME\t";
            }
        if($Rows['DURATION'] != ""){
	    $DURATION = $Rows['DURATION'];
    	    $alert .= "DURATION>".$DURATION."m\t";
            }
	$alert .= "\n";
        if($Rows['REPEAT'] != ""){
    	    $REPEAT = "REPEAT=".$Rows['REPEAT']."m";
            }
        if($Rows['EMAIL'] != ""){
            $EMAIL = $Rows['EMAIL'];
            if($REPEAT){
        	$alert .= "\tMAIL $EMAIL\t $REPEAT\n";
            }else{
        	$alert .= "\tMAIL $EMAIL\n";
        	}
    	    }	
        if($Rows['RECOVERED'] == 1){
            $RECOVERED = $Rows['RECOVERED'];
    	    $alert .= " RECOVERED";
            }
            
        $i++;
    	$alert .= "\n\n";
        fwrite($file, $alert);
        $HOSTNAME = "";
        $PAGEGROUPID ="";
        $COLOR = "";
        $DURATION = "";
        $SERVICE = "";
        $EMAIL = "";
        $TIME = "";
        $REPEAT = "";
        $RECOVERED = "";
        $ONCALL = "";
        }
    fclose($file);
    mysql_close($con);
}




function activateHosts($dbhost,$dbuser,$dbpass,$db,$analyzefile){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM HOSTS ORDER BY PAGEGROUP";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
    $i =0;
    #echo $numrows;
    $file = fopen("$analyzefile","w+") or exit("Unable to open file!");    
    while($Rows = mysql_fetch_array($result)){
	$HOSTID = $Rows['ID'];
	$hostname = trim($Rows['HOSTNAME']);
	$analyze = "HOST=".$hostname."\n";
	$SQL5 = "SELECT * FROM HOSTDISKS WHERE HOSTID = '$HOSTID'";
#    	echo $SQL5;
	$result5 = mysql_query($SQL5) or die('A error occured: ' . $SQL5);
	while($Row5 = mysql_fetch_array($result5)){
	    if($Row5['DISK'] and $Row5['DISK'] != ""){$DISK = $Row5['DISK'];}
	    if($Row5['WARN'] and $Row5['WARN'] != ""){$WARN = $Row5['WARN'];}
	    if($Row5['PANIC'] and $Row5['PANIC'] != ""){$PANIC = $Row5['PANIC'];}
	    if($Row5['IGNORE'] and $Row5['IGNORE'] != ""){$IGNORE = $Row5['IGNORE'];}
	    if($IGNORE == 1){
		$analyze .= "\tDISK $DISK IGNORE\n";
	    }else{
		$analyze .= "\tDISK $DISK $WARN $PANIC\n";	    
	    }
	    $IGNORE = "";
	    $PANIC = "";
	    $WARN = "";	
	 }
	$SQL1 = "SELECT * FROM SYSTEMTESTS WHERE HOSTID = '$HOSTID'";
#    	echo $SQL1;
	$result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
	while($Row1 = mysql_fetch_array($result1)){
	    if(is_numeric($Row1['MEMPHYSWARN']) and $Row1['MEMPHYSWARN'] != 0){$MEMPHYSWARN = $Row1['MEMPHYSWARN'];}else{$MEMPHYSWARN = 99;}
	    if(is_numeric($Row1['MEMPHYSCRIT']) and $Row1['MEMPHYSCRIT'] != 0){$MEMPHYSCRIT = $Row1['MEMPHYSCRIT'];}else{$MEMPHYSCRIT = 100;}
	    if(is_numeric($Row1['MEMACTWARN']) and $Row1['MEMACTWARN'] != 0){$MEMACTWARN = $Row1['MEMACTWARN'];}else{$MEMACTWARN = 99;}
	    if(is_numeric($Row1['MEMACTCRIT']) and $Row1['MEMACTCRIT'] != 0){$MEMACTCRIT = $Row1['MEMACTCRIT'];}else{$MEMACTCRIT = 100;}
	    if(is_numeric($Row1['MEMSWAPWARN']) and $Row1['MEMSWAPWARN'] != 0){$MEMSWAPWARN = $Row1['MEMSWAPWARN'];}else{$MEMSWAPWARN = 99;}
	    if(is_numeric($Row1['MEMSWAPCRIT']) and $Row1['MEMSWAPCRIT'] != 0){$MEMSWAPCRIT = $Row1['MEMSWAPCRIT'];}else{$MEMSWAPCRIT = 100;}
	    $analyze .= "\tMEMPHYS $MEMPHYSWARN $MEMPHYSCRIT\n";
	    $analyze .= "\tMEMSWAP $MEMSWAPWARN $MEMSWAPCRIT\n";
	    $analyze .= "\tMEMACT $MEMACTWARN $MEMACTCRIT\n";
	    if(is_numeric($Row1['LOADWARN']) and $Row1['LOADWARN'] != 0){$LOADWARN = $Row1['LOADWARN'];}else{$LOADWARN = 99;}
	    if(is_numeric($Row1['LOADCRIT']) and $Row1['LOADCRIT'] != 0){$LOADCRIT = $Row1['LOADCRIT'];}else{$LOADCRIT = 100;}
	    $analyze .= "\tLOAD $LOADWARN $LOADCRIT\n";
	    if($Row1['REBOOT'] and $Row1['REBOOT'] != ""){$REBOOT = $Row1['REBOOT'];}
	    if(is_numeric($Row1['UPTIME']) and $Row1['UPTIME'] != 0){$UPTIME = $Row1['UPTIME'];}
	    $analyze .= "\tUP ".$UPTIME."m $REBOOT\n";
	    if(is_numeric($Row1['CLOCK']) and $Row1['CLOCK'] != 0){$CLOCK = $Row1['CLOCK'];}
	    $analyze .= "\tCLOCK ".$CLOCK." red\n";
	    if(is_numeric($Row1['DISKWARN']) and $Row1['DISKWARN'] != 0){$DISKWARN = $Row1['DISKWARN'];}else{$DISKWARN = 99;}
	    if(is_numeric($Row1['DISKCRIT']) and $Row1['DISKCRIT'] != 0){$DISKCRIT = $Row1['DISKCRIT'];}else{$DISKCRIT = 100;}
	    $analyze .= "\tDISK * $DISKWARN $DISKCRIT\n";
	    }
	    
	$SQL2 = "SELECT * FROM HOSTSVCS WHERE HOSTID = '$HOSTID'";
#    	echo $SQL2;
	$result2 = mysql_query($SQL2) or die('A error occured: ' . $SQL2);
	while($Row2 = mysql_fetch_array($result2)){
	    if($Row2['SERVICENAME'] and $Row2['SERVICENAME'] != ""){$SERVICENAME = $Row2['SERVICENAME'];}
	    if($Row2['STARTUP'] and $Row2['STARTUP'] != ""){$STARTUP = $Row2['STARTUP'];}
	    if($Row2['STATUS'] and $Row2['STATUS'] != ""){$STATUS = $Row2['STATUS'];}
	    $analyze .= "\tSVC $SERVICENAME status=$STATUS startup=$STARTUP\n";
	    $SERVICENAME = "";
	    $STATUS = "";
	    $STARTUP = "";
	    }
	$SQL3 = "SELECT * FROM HOSTPROCS WHERE HOSTID = '$HOSTID'";
#    	echo $SQL3;
	$result3 = mysql_query($SQL3) or die('A error occured: ' . $SQL3);
	while($Row3 = mysql_fetch_array($result3)){
	    if($Row3['PROC'] and $Row3['PROC'] != ""){$PROC = $Row3['PROC'];}
	    if($Row3['MINCOUNT'] and $Row3['MINCOUNT'] != ""){$MINCOUNT = $Row3['MINCOUNT'];}
	    if($Row3['MAXCOUNT'] and $Row3['MAXCOUNT'] != ""){$MAXCOUNT = $Row3['MAXCOUNT'];}
	    $analyze .= "\tPROC $PROC $MINCOUNT $MAXCOUNT red\n";
	    $PROC = "";
	    $MINCOUNT = "";
	    $MAXCOUNT = "";
	    }
	$SQL4 = "SELECT * FROM HOSTLOGS WHERE HOSTID = '$HOSTID'";
#    	echo $SQL4;
	$result4 = mysql_query($SQL4) or die('A error occured: ' . $SQL4);
	while($Row4 = mysql_fetch_array($result4)){
	    if($Row4['LOG'] and $Row4['LOG'] != ""){$LOG = $Row4['LOG'];}
	    $analyze .= "\tLOG $LOG ";
	    if($Row4['MATCH'] and $Row4['MATCH'] != ""){$analyze .= " ".$Row4['MATCH']." ";}
	    if($Row4['COLOR'] and $Row4['COLOR'] != ""){$analyze .= " COLOR=\"". $Row4['COLOR']."\" ";}
	    if($Row4['IGNORE'] and $Row4['IGNORE'] != ""){$analyze .= " IGNORE=\"".$Row4['IGNORE']."\" ";}
	    $analyze .= "\n";
	    $LOG = "";
	    $MATCH = "";
	    $COLOR = "";
	    $IGNORE = "";
	    }
	    
	$analyze .= "\n";            
        fwrite($file, $analyze);
        }
    fclose($file);
    mysql_close($con);
}

function activateGroups($dbhost,$dbuser,$dbpass,$db,$hostsfile,$title){
    $con = mysql_connect($dbhost,$dbuser,$dbpass);
    $cats = mysql_select_db($db, $con);
    $SQL = "SELECT * FROM PAGEGROUPS ORDER BY NAME";
#    echo $SQL;
    $result = mysql_query($SQL) or die('A error occured: ' . $SQL);
    $numrows = mysql_num_rows($result);
    $i =0;
#    echo $numrows;
    $file = fopen("$hostsfile","w+") or exit("Unable to open file!");
    $hostconfig = "title $title\n";
    fwrite($file, $hostconfig);
    while($Rows = mysql_fetch_array($result)){
	$ID = $Rows['ID'];
	$pagename = trim($Rows['NAME']);
	$pagename = str_replace(" ","_",$pagename);;
	$hostconfig = "page ".$pagename." ".$Rows['NAME']."\n";
	$hostconfig .= "title ".$Rows['TITLE']." \n\n";
	$SQL1 = "SELECT * FROM HOSTS WHERE PAGEGROUP = '$ID' ORDER BY HOSTNAME";
#    	echo $SQL1;
#echo $hostconfig;
	$result1 = mysql_query($SQL1) or die('A error occured: ' . $SQL1);
	while($Row1 = mysql_fetch_array($result1)){
	    $HOSTID = $Row1['ID'];
    	    $SQL2 = "SELECT * FROM EXTERNAL_TESTS WHERE HOST = '$HOSTID'";
#    		echo $SQL2;
	    $result2 = mysql_query($SQL2) or die('A error occured: ' . $SQL2);
	    while($Row2 = mysql_fetch_array($result2)){
	        $hostconfig .= $Row1['IPADDRESS']."\t".$Row1['HOSTNAME']." # COMMENT:\"".$Row1['COMMENT']."\" NAME:\"".$Row1['NAME']."\" ";
		if($Row2['CONN'] == 1){$hostconfig .= " conn ";}else{$hostconfig .= " noconn ";} 	
		if($Row2['HTTP'] != ""){$hostconfig .= " ".$Row2['HTTP']." ";} 	
		if($Row2['FTP'] == "1"){$hostconfig .= " ftp  ";} 	
		if($Row2['SSH'] == "1"){$hostconfig .= " ssh ";} 	
		if($Row2['TELNET'] == "1"){$hostconfig .= " telnet ";} 	
		if($Row2['SMTP'] == "1"){$hostconfig .= " smtp ";} 	
		if($Row2['POP3'] == "1"){$hostconfig .= " pop3 ";} 	
		if($Row2['IMAP'] == "1"){$hostconfig .= " imap ";} 	
		if($Row2['FTPS'] == "1"){$hostconfig .= " ftps ";} 	
		if($Row2['TELNETS'] == "1"){$hostconfig .= " telnets ";} 	
		if($Row2['SMTPS'] == "1"){$hostconfig .= " smtps ";} 	
		if($Row2['POP3S'] == "1"){$hostconfig .= " pop3s ";} 	
		if($Row2['IMAPS'] == "1"){$hostconfig .= " imaps ";} 	
		if($Row2['ESXI'] == "1"){$hostconfig .= " esxi ";} 	
		$hostconfig .= "\n";
	        }    
        }
      $hostconfig .= "\n\n";
      fwrite($file, $hostconfig);
    }
    fclose($file);
    mysql_close($con);
}





?>
